package concurrency.week10;

class Generator extends Thread {

	private Pipe<Integer> outpipe;

	public Generator(Pipe<Integer> outpipe) {
		this.outpipe = outpipe;
	}

	public void run() {
		try {
			for (int i = 2; i <= Primes.MAXNUM; i++) {
				System.out.println("Generator: sent out " + i);
				outpipe.put(i);
				Thread.sleep(200);
			}
			System.out.println("Generator: sent out " + Primes.EOS);
			outpipe.put(Primes.EOS);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

}