/*
@author  j.n.magee 25/04/98
 */
package concurrency.week10;

import java.util.ArrayList;

public class Primes {

	static int EOS = -1;

	static int MAXNUM = 35;

	static int FILTERNUM = 12;

	static boolean buffered = true;

	public static void main(String[] args) throws InterruptedException {

		ArrayList<Pipe<Integer>> pipes = new ArrayList<Pipe<Integer>>();

		for (int i = 0; i < FILTERNUM; i++)
			if (buffered) {

				pipes.add(new PipeImplBuf<Integer>());
			} else {
				pipes.add(new PipeImplUnBuf<Integer>());
			}

		Generator gen = new Generator(pipes.get(0));
		Filter filter[] = new Filter[FILTERNUM];

		for (int i = 0; i < FILTERNUM - 1; i++) {
			filter[i] = new Filter(pipes.get(i), pipes.get(i + 1), i + 1);
		}
		filter[FILTERNUM - 1] = new Filter(pipes.get(FILTERNUM - 1), null,
				FILTERNUM);

		gen.start();
		for (int i = 0; i < FILTERNUM; i++) {
			filter[i].start();
		}

		gen.join();
		for (int i = 0; i < FILTERNUM; i++) {
			filter[i].join();
		}

	}

}
